import { ParseTreeListener } from "antlr4ts/tree/ParseTreeListener";
import { CompilationUnitContext } from "./EscriptLooseParser";
import { ModuleUnitContext } from "./EscriptLooseParser";
import { ModuleDeclarationStatementContext } from "./EscriptLooseParser";
import { ModuleFunctionDeclarationContext } from "./EscriptLooseParser";
import { ModuleFunctionParameterListContext } from "./EscriptLooseParser";
import { ModuleFunctionParameterContext } from "./EscriptLooseParser";
import { UnitExpressionContext } from "./EscriptLooseParser";
import { TopLevelDeclarationContext } from "./EscriptLooseParser";
import { FunctionDeclarationContext } from "./EscriptLooseParser";
import { StringIdentifierContext } from "./EscriptLooseParser";
import { UseDeclarationContext } from "./EscriptLooseParser";
import { IncludeDeclarationContext } from "./EscriptLooseParser";
import { ProgramDeclarationContext } from "./EscriptLooseParser";
import { StatementContext } from "./EscriptLooseParser";
import { IfStatementContext } from "./EscriptLooseParser";
import { GotoStatementContext } from "./EscriptLooseParser";
import { ReturnStatementContext } from "./EscriptLooseParser";
import { ConstStatementContext } from "./EscriptLooseParser";
import { VarStatementContext } from "./EscriptLooseParser";
import { DoStatementContext } from "./EscriptLooseParser";
import { WhileStatementContext } from "./EscriptLooseParser";
import { ExitStatementContext } from "./EscriptLooseParser";
import { DeclareStatementContext } from "./EscriptLooseParser";
import { BreakStatementContext } from "./EscriptLooseParser";
import { ContinueStatementContext } from "./EscriptLooseParser";
import { ForStatementContext } from "./EscriptLooseParser";
import { ForeachStatementContext } from "./EscriptLooseParser";
import { RepeatStatementContext } from "./EscriptLooseParser";
import { CaseStatementContext } from "./EscriptLooseParser";
import { EnumStatementContext } from "./EscriptLooseParser";
import { BlockContext } from "./EscriptLooseParser";
import { VariableDeclarationInitializerContext } from "./EscriptLooseParser";
import { EnumListContext } from "./EscriptLooseParser";
import { EnumListEntryContext } from "./EscriptLooseParser";
import { SwitchBlockStatementGroupContext } from "./EscriptLooseParser";
import { SwitchLabelContext } from "./EscriptLooseParser";
import { ForGroupContext } from "./EscriptLooseParser";
import { BasicForStatementContext } from "./EscriptLooseParser";
import { CstyleForStatementContext } from "./EscriptLooseParser";
import { IdentifierListContext } from "./EscriptLooseParser";
import { VariableDeclarationListContext } from "./EscriptLooseParser";
import { VariableDeclarationContext } from "./EscriptLooseParser";
import { ProgramParametersContext } from "./EscriptLooseParser";
import { ProgramParameterListContext } from "./EscriptLooseParser";
import { ProgramParameterContext } from "./EscriptLooseParser";
import { FunctionParametersContext } from "./EscriptLooseParser";
import { FunctionParameterListContext } from "./EscriptLooseParser";
import { FunctionParameterContext } from "./EscriptLooseParser";
import { ScopedMethodCallContext } from "./EscriptLooseParser";
import { MissingTokenContext } from "./EscriptLooseParser";
import { ExpressionContext } from "./EscriptLooseParser";
import { PrimaryContext } from "./EscriptLooseParser";
import { ParExpressionContext } from "./EscriptLooseParser";
import { ExpressionListContext } from "./EscriptLooseParser";
import { MethodCallArgumentContext } from "./EscriptLooseParser";
import { MethodCallArgumentListContext } from "./EscriptLooseParser";
import { MethodCallContext } from "./EscriptLooseParser";
import { MemberCallContext } from "./EscriptLooseParser";
import { StructInitializerExpressionContext } from "./EscriptLooseParser";
import { StructInitializerExpressionListContext } from "./EscriptLooseParser";
import { StructInitializerContext } from "./EscriptLooseParser";
import { DictInitializerExpressionContext } from "./EscriptLooseParser";
import { DictInitializerExpressionListContext } from "./EscriptLooseParser";
import { DictInitializerContext } from "./EscriptLooseParser";
import { ArrayInitializerContext } from "./EscriptLooseParser";
import { LiteralContext } from "./EscriptLooseParser";
import { IntegerLiteralContext } from "./EscriptLooseParser";
import { FloatLiteralContext } from "./EscriptLooseParser";
/**
 * This interface defines a complete listener for a parse tree produced by
 * `EscriptLooseParser`.
 */
export interface EscriptLooseParserListener extends ParseTreeListener {
    /**
     * Enter a parse tree produced by `EscriptLooseParser.compilationUnit`.
     * @param ctx the parse tree
     */
    enterCompilationUnit?: (ctx: CompilationUnitContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.compilationUnit`.
     * @param ctx the parse tree
     */
    exitCompilationUnit?: (ctx: CompilationUnitContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.moduleUnit`.
     * @param ctx the parse tree
     */
    enterModuleUnit?: (ctx: ModuleUnitContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.moduleUnit`.
     * @param ctx the parse tree
     */
    exitModuleUnit?: (ctx: ModuleUnitContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.moduleDeclarationStatement`.
     * @param ctx the parse tree
     */
    enterModuleDeclarationStatement?: (ctx: ModuleDeclarationStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.moduleDeclarationStatement`.
     * @param ctx the parse tree
     */
    exitModuleDeclarationStatement?: (ctx: ModuleDeclarationStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.moduleFunctionDeclaration`.
     * @param ctx the parse tree
     */
    enterModuleFunctionDeclaration?: (ctx: ModuleFunctionDeclarationContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.moduleFunctionDeclaration`.
     * @param ctx the parse tree
     */
    exitModuleFunctionDeclaration?: (ctx: ModuleFunctionDeclarationContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.moduleFunctionParameterList`.
     * @param ctx the parse tree
     */
    enterModuleFunctionParameterList?: (ctx: ModuleFunctionParameterListContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.moduleFunctionParameterList`.
     * @param ctx the parse tree
     */
    exitModuleFunctionParameterList?: (ctx: ModuleFunctionParameterListContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.moduleFunctionParameter`.
     * @param ctx the parse tree
     */
    enterModuleFunctionParameter?: (ctx: ModuleFunctionParameterContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.moduleFunctionParameter`.
     * @param ctx the parse tree
     */
    exitModuleFunctionParameter?: (ctx: ModuleFunctionParameterContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.unitExpression`.
     * @param ctx the parse tree
     */
    enterUnitExpression?: (ctx: UnitExpressionContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.unitExpression`.
     * @param ctx the parse tree
     */
    exitUnitExpression?: (ctx: UnitExpressionContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.topLevelDeclaration`.
     * @param ctx the parse tree
     */
    enterTopLevelDeclaration?: (ctx: TopLevelDeclarationContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.topLevelDeclaration`.
     * @param ctx the parse tree
     */
    exitTopLevelDeclaration?: (ctx: TopLevelDeclarationContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.functionDeclaration`.
     * @param ctx the parse tree
     */
    enterFunctionDeclaration?: (ctx: FunctionDeclarationContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.functionDeclaration`.
     * @param ctx the parse tree
     */
    exitFunctionDeclaration?: (ctx: FunctionDeclarationContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.stringIdentifier`.
     * @param ctx the parse tree
     */
    enterStringIdentifier?: (ctx: StringIdentifierContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.stringIdentifier`.
     * @param ctx the parse tree
     */
    exitStringIdentifier?: (ctx: StringIdentifierContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.useDeclaration`.
     * @param ctx the parse tree
     */
    enterUseDeclaration?: (ctx: UseDeclarationContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.useDeclaration`.
     * @param ctx the parse tree
     */
    exitUseDeclaration?: (ctx: UseDeclarationContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.includeDeclaration`.
     * @param ctx the parse tree
     */
    enterIncludeDeclaration?: (ctx: IncludeDeclarationContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.includeDeclaration`.
     * @param ctx the parse tree
     */
    exitIncludeDeclaration?: (ctx: IncludeDeclarationContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.programDeclaration`.
     * @param ctx the parse tree
     */
    enterProgramDeclaration?: (ctx: ProgramDeclarationContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.programDeclaration`.
     * @param ctx the parse tree
     */
    exitProgramDeclaration?: (ctx: ProgramDeclarationContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.statement`.
     * @param ctx the parse tree
     */
    enterStatement?: (ctx: StatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.statement`.
     * @param ctx the parse tree
     */
    exitStatement?: (ctx: StatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.ifStatement`.
     * @param ctx the parse tree
     */
    enterIfStatement?: (ctx: IfStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.ifStatement`.
     * @param ctx the parse tree
     */
    exitIfStatement?: (ctx: IfStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.gotoStatement`.
     * @param ctx the parse tree
     */
    enterGotoStatement?: (ctx: GotoStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.gotoStatement`.
     * @param ctx the parse tree
     */
    exitGotoStatement?: (ctx: GotoStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.returnStatement`.
     * @param ctx the parse tree
     */
    enterReturnStatement?: (ctx: ReturnStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.returnStatement`.
     * @param ctx the parse tree
     */
    exitReturnStatement?: (ctx: ReturnStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.constStatement`.
     * @param ctx the parse tree
     */
    enterConstStatement?: (ctx: ConstStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.constStatement`.
     * @param ctx the parse tree
     */
    exitConstStatement?: (ctx: ConstStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.varStatement`.
     * @param ctx the parse tree
     */
    enterVarStatement?: (ctx: VarStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.varStatement`.
     * @param ctx the parse tree
     */
    exitVarStatement?: (ctx: VarStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.doStatement`.
     * @param ctx the parse tree
     */
    enterDoStatement?: (ctx: DoStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.doStatement`.
     * @param ctx the parse tree
     */
    exitDoStatement?: (ctx: DoStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.whileStatement`.
     * @param ctx the parse tree
     */
    enterWhileStatement?: (ctx: WhileStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.whileStatement`.
     * @param ctx the parse tree
     */
    exitWhileStatement?: (ctx: WhileStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.exitStatement`.
     * @param ctx the parse tree
     */
    enterExitStatement?: (ctx: ExitStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.exitStatement`.
     * @param ctx the parse tree
     */
    exitExitStatement?: (ctx: ExitStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.declareStatement`.
     * @param ctx the parse tree
     */
    enterDeclareStatement?: (ctx: DeclareStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.declareStatement`.
     * @param ctx the parse tree
     */
    exitDeclareStatement?: (ctx: DeclareStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.breakStatement`.
     * @param ctx the parse tree
     */
    enterBreakStatement?: (ctx: BreakStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.breakStatement`.
     * @param ctx the parse tree
     */
    exitBreakStatement?: (ctx: BreakStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.continueStatement`.
     * @param ctx the parse tree
     */
    enterContinueStatement?: (ctx: ContinueStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.continueStatement`.
     * @param ctx the parse tree
     */
    exitContinueStatement?: (ctx: ContinueStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.forStatement`.
     * @param ctx the parse tree
     */
    enterForStatement?: (ctx: ForStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.forStatement`.
     * @param ctx the parse tree
     */
    exitForStatement?: (ctx: ForStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.foreachStatement`.
     * @param ctx the parse tree
     */
    enterForeachStatement?: (ctx: ForeachStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.foreachStatement`.
     * @param ctx the parse tree
     */
    exitForeachStatement?: (ctx: ForeachStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.repeatStatement`.
     * @param ctx the parse tree
     */
    enterRepeatStatement?: (ctx: RepeatStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.repeatStatement`.
     * @param ctx the parse tree
     */
    exitRepeatStatement?: (ctx: RepeatStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.caseStatement`.
     * @param ctx the parse tree
     */
    enterCaseStatement?: (ctx: CaseStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.caseStatement`.
     * @param ctx the parse tree
     */
    exitCaseStatement?: (ctx: CaseStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.enumStatement`.
     * @param ctx the parse tree
     */
    enterEnumStatement?: (ctx: EnumStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.enumStatement`.
     * @param ctx the parse tree
     */
    exitEnumStatement?: (ctx: EnumStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.block`.
     * @param ctx the parse tree
     */
    enterBlock?: (ctx: BlockContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.block`.
     * @param ctx the parse tree
     */
    exitBlock?: (ctx: BlockContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.variableDeclarationInitializer`.
     * @param ctx the parse tree
     */
    enterVariableDeclarationInitializer?: (ctx: VariableDeclarationInitializerContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.variableDeclarationInitializer`.
     * @param ctx the parse tree
     */
    exitVariableDeclarationInitializer?: (ctx: VariableDeclarationInitializerContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.enumList`.
     * @param ctx the parse tree
     */
    enterEnumList?: (ctx: EnumListContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.enumList`.
     * @param ctx the parse tree
     */
    exitEnumList?: (ctx: EnumListContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.enumListEntry`.
     * @param ctx the parse tree
     */
    enterEnumListEntry?: (ctx: EnumListEntryContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.enumListEntry`.
     * @param ctx the parse tree
     */
    exitEnumListEntry?: (ctx: EnumListEntryContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.switchBlockStatementGroup`.
     * @param ctx the parse tree
     */
    enterSwitchBlockStatementGroup?: (ctx: SwitchBlockStatementGroupContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.switchBlockStatementGroup`.
     * @param ctx the parse tree
     */
    exitSwitchBlockStatementGroup?: (ctx: SwitchBlockStatementGroupContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.switchLabel`.
     * @param ctx the parse tree
     */
    enterSwitchLabel?: (ctx: SwitchLabelContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.switchLabel`.
     * @param ctx the parse tree
     */
    exitSwitchLabel?: (ctx: SwitchLabelContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.forGroup`.
     * @param ctx the parse tree
     */
    enterForGroup?: (ctx: ForGroupContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.forGroup`.
     * @param ctx the parse tree
     */
    exitForGroup?: (ctx: ForGroupContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.basicForStatement`.
     * @param ctx the parse tree
     */
    enterBasicForStatement?: (ctx: BasicForStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.basicForStatement`.
     * @param ctx the parse tree
     */
    exitBasicForStatement?: (ctx: BasicForStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.cstyleForStatement`.
     * @param ctx the parse tree
     */
    enterCstyleForStatement?: (ctx: CstyleForStatementContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.cstyleForStatement`.
     * @param ctx the parse tree
     */
    exitCstyleForStatement?: (ctx: CstyleForStatementContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.identifierList`.
     * @param ctx the parse tree
     */
    enterIdentifierList?: (ctx: IdentifierListContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.identifierList`.
     * @param ctx the parse tree
     */
    exitIdentifierList?: (ctx: IdentifierListContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.variableDeclarationList`.
     * @param ctx the parse tree
     */
    enterVariableDeclarationList?: (ctx: VariableDeclarationListContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.variableDeclarationList`.
     * @param ctx the parse tree
     */
    exitVariableDeclarationList?: (ctx: VariableDeclarationListContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.variableDeclaration`.
     * @param ctx the parse tree
     */
    enterVariableDeclaration?: (ctx: VariableDeclarationContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.variableDeclaration`.
     * @param ctx the parse tree
     */
    exitVariableDeclaration?: (ctx: VariableDeclarationContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.programParameters`.
     * @param ctx the parse tree
     */
    enterProgramParameters?: (ctx: ProgramParametersContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.programParameters`.
     * @param ctx the parse tree
     */
    exitProgramParameters?: (ctx: ProgramParametersContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.programParameterList`.
     * @param ctx the parse tree
     */
    enterProgramParameterList?: (ctx: ProgramParameterListContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.programParameterList`.
     * @param ctx the parse tree
     */
    exitProgramParameterList?: (ctx: ProgramParameterListContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.programParameter`.
     * @param ctx the parse tree
     */
    enterProgramParameter?: (ctx: ProgramParameterContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.programParameter`.
     * @param ctx the parse tree
     */
    exitProgramParameter?: (ctx: ProgramParameterContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.functionParameters`.
     * @param ctx the parse tree
     */
    enterFunctionParameters?: (ctx: FunctionParametersContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.functionParameters`.
     * @param ctx the parse tree
     */
    exitFunctionParameters?: (ctx: FunctionParametersContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.functionParameterList`.
     * @param ctx the parse tree
     */
    enterFunctionParameterList?: (ctx: FunctionParameterListContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.functionParameterList`.
     * @param ctx the parse tree
     */
    exitFunctionParameterList?: (ctx: FunctionParameterListContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.functionParameter`.
     * @param ctx the parse tree
     */
    enterFunctionParameter?: (ctx: FunctionParameterContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.functionParameter`.
     * @param ctx the parse tree
     */
    exitFunctionParameter?: (ctx: FunctionParameterContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.scopedMethodCall`.
     * @param ctx the parse tree
     */
    enterScopedMethodCall?: (ctx: ScopedMethodCallContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.scopedMethodCall`.
     * @param ctx the parse tree
     */
    exitScopedMethodCall?: (ctx: ScopedMethodCallContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.missingToken`.
     * @param ctx the parse tree
     */
    enterMissingToken?: (ctx: MissingTokenContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.missingToken`.
     * @param ctx the parse tree
     */
    exitMissingToken?: (ctx: MissingTokenContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.expression`.
     * @param ctx the parse tree
     */
    enterExpression?: (ctx: ExpressionContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.expression`.
     * @param ctx the parse tree
     */
    exitExpression?: (ctx: ExpressionContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.primary`.
     * @param ctx the parse tree
     */
    enterPrimary?: (ctx: PrimaryContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.primary`.
     * @param ctx the parse tree
     */
    exitPrimary?: (ctx: PrimaryContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.parExpression`.
     * @param ctx the parse tree
     */
    enterParExpression?: (ctx: ParExpressionContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.parExpression`.
     * @param ctx the parse tree
     */
    exitParExpression?: (ctx: ParExpressionContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.expressionList`.
     * @param ctx the parse tree
     */
    enterExpressionList?: (ctx: ExpressionListContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.expressionList`.
     * @param ctx the parse tree
     */
    exitExpressionList?: (ctx: ExpressionListContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.methodCallArgument`.
     * @param ctx the parse tree
     */
    enterMethodCallArgument?: (ctx: MethodCallArgumentContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.methodCallArgument`.
     * @param ctx the parse tree
     */
    exitMethodCallArgument?: (ctx: MethodCallArgumentContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.methodCallArgumentList`.
     * @param ctx the parse tree
     */
    enterMethodCallArgumentList?: (ctx: MethodCallArgumentListContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.methodCallArgumentList`.
     * @param ctx the parse tree
     */
    exitMethodCallArgumentList?: (ctx: MethodCallArgumentListContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.methodCall`.
     * @param ctx the parse tree
     */
    enterMethodCall?: (ctx: MethodCallContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.methodCall`.
     * @param ctx the parse tree
     */
    exitMethodCall?: (ctx: MethodCallContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.memberCall`.
     * @param ctx the parse tree
     */
    enterMemberCall?: (ctx: MemberCallContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.memberCall`.
     * @param ctx the parse tree
     */
    exitMemberCall?: (ctx: MemberCallContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.structInitializerExpression`.
     * @param ctx the parse tree
     */
    enterStructInitializerExpression?: (ctx: StructInitializerExpressionContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.structInitializerExpression`.
     * @param ctx the parse tree
     */
    exitStructInitializerExpression?: (ctx: StructInitializerExpressionContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.structInitializerExpressionList`.
     * @param ctx the parse tree
     */
    enterStructInitializerExpressionList?: (ctx: StructInitializerExpressionListContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.structInitializerExpressionList`.
     * @param ctx the parse tree
     */
    exitStructInitializerExpressionList?: (ctx: StructInitializerExpressionListContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.structInitializer`.
     * @param ctx the parse tree
     */
    enterStructInitializer?: (ctx: StructInitializerContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.structInitializer`.
     * @param ctx the parse tree
     */
    exitStructInitializer?: (ctx: StructInitializerContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.dictInitializerExpression`.
     * @param ctx the parse tree
     */
    enterDictInitializerExpression?: (ctx: DictInitializerExpressionContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.dictInitializerExpression`.
     * @param ctx the parse tree
     */
    exitDictInitializerExpression?: (ctx: DictInitializerExpressionContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.dictInitializerExpressionList`.
     * @param ctx the parse tree
     */
    enterDictInitializerExpressionList?: (ctx: DictInitializerExpressionListContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.dictInitializerExpressionList`.
     * @param ctx the parse tree
     */
    exitDictInitializerExpressionList?: (ctx: DictInitializerExpressionListContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.dictInitializer`.
     * @param ctx the parse tree
     */
    enterDictInitializer?: (ctx: DictInitializerContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.dictInitializer`.
     * @param ctx the parse tree
     */
    exitDictInitializer?: (ctx: DictInitializerContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.arrayInitializer`.
     * @param ctx the parse tree
     */
    enterArrayInitializer?: (ctx: ArrayInitializerContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.arrayInitializer`.
     * @param ctx the parse tree
     */
    exitArrayInitializer?: (ctx: ArrayInitializerContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.literal`.
     * @param ctx the parse tree
     */
    enterLiteral?: (ctx: LiteralContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.literal`.
     * @param ctx the parse tree
     */
    exitLiteral?: (ctx: LiteralContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.integerLiteral`.
     * @param ctx the parse tree
     */
    enterIntegerLiteral?: (ctx: IntegerLiteralContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.integerLiteral`.
     * @param ctx the parse tree
     */
    exitIntegerLiteral?: (ctx: IntegerLiteralContext) => void;
    /**
     * Enter a parse tree produced by `EscriptLooseParser.floatLiteral`.
     * @param ctx the parse tree
     */
    enterFloatLiteral?: (ctx: FloatLiteralContext) => void;
    /**
     * Exit a parse tree produced by `EscriptLooseParser.floatLiteral`.
     * @param ctx the parse tree
     */
    exitFloatLiteral?: (ctx: FloatLiteralContext) => void;
}
