import { ParseTreeVisitor } from "antlr4ts/tree/ParseTreeVisitor";
import { CompilationUnitContext } from "./EscriptLooseParser";
import { ModuleUnitContext } from "./EscriptLooseParser";
import { ModuleDeclarationStatementContext } from "./EscriptLooseParser";
import { ModuleFunctionDeclarationContext } from "./EscriptLooseParser";
import { ModuleFunctionParameterListContext } from "./EscriptLooseParser";
import { ModuleFunctionParameterContext } from "./EscriptLooseParser";
import { UnitExpressionContext } from "./EscriptLooseParser";
import { TopLevelDeclarationContext } from "./EscriptLooseParser";
import { FunctionDeclarationContext } from "./EscriptLooseParser";
import { StringIdentifierContext } from "./EscriptLooseParser";
import { UseDeclarationContext } from "./EscriptLooseParser";
import { IncludeDeclarationContext } from "./EscriptLooseParser";
import { ProgramDeclarationContext } from "./EscriptLooseParser";
import { StatementContext } from "./EscriptLooseParser";
import { IfStatementContext } from "./EscriptLooseParser";
import { GotoStatementContext } from "./EscriptLooseParser";
import { ReturnStatementContext } from "./EscriptLooseParser";
import { ConstStatementContext } from "./EscriptLooseParser";
import { VarStatementContext } from "./EscriptLooseParser";
import { DoStatementContext } from "./EscriptLooseParser";
import { WhileStatementContext } from "./EscriptLooseParser";
import { ExitStatementContext } from "./EscriptLooseParser";
import { DeclareStatementContext } from "./EscriptLooseParser";
import { BreakStatementContext } from "./EscriptLooseParser";
import { ContinueStatementContext } from "./EscriptLooseParser";
import { ForStatementContext } from "./EscriptLooseParser";
import { ForeachStatementContext } from "./EscriptLooseParser";
import { RepeatStatementContext } from "./EscriptLooseParser";
import { CaseStatementContext } from "./EscriptLooseParser";
import { EnumStatementContext } from "./EscriptLooseParser";
import { BlockContext } from "./EscriptLooseParser";
import { VariableDeclarationInitializerContext } from "./EscriptLooseParser";
import { EnumListContext } from "./EscriptLooseParser";
import { EnumListEntryContext } from "./EscriptLooseParser";
import { SwitchBlockStatementGroupContext } from "./EscriptLooseParser";
import { SwitchLabelContext } from "./EscriptLooseParser";
import { ForGroupContext } from "./EscriptLooseParser";
import { BasicForStatementContext } from "./EscriptLooseParser";
import { CstyleForStatementContext } from "./EscriptLooseParser";
import { IdentifierListContext } from "./EscriptLooseParser";
import { VariableDeclarationListContext } from "./EscriptLooseParser";
import { VariableDeclarationContext } from "./EscriptLooseParser";
import { ProgramParametersContext } from "./EscriptLooseParser";
import { ProgramParameterListContext } from "./EscriptLooseParser";
import { ProgramParameterContext } from "./EscriptLooseParser";
import { FunctionParametersContext } from "./EscriptLooseParser";
import { FunctionParameterListContext } from "./EscriptLooseParser";
import { FunctionParameterContext } from "./EscriptLooseParser";
import { ScopedMethodCallContext } from "./EscriptLooseParser";
import { MissingTokenContext } from "./EscriptLooseParser";
import { ExpressionContext } from "./EscriptLooseParser";
import { PrimaryContext } from "./EscriptLooseParser";
import { ParExpressionContext } from "./EscriptLooseParser";
import { ExpressionListContext } from "./EscriptLooseParser";
import { MethodCallArgumentContext } from "./EscriptLooseParser";
import { MethodCallArgumentListContext } from "./EscriptLooseParser";
import { MethodCallContext } from "./EscriptLooseParser";
import { MemberCallContext } from "./EscriptLooseParser";
import { StructInitializerExpressionContext } from "./EscriptLooseParser";
import { StructInitializerExpressionListContext } from "./EscriptLooseParser";
import { StructInitializerContext } from "./EscriptLooseParser";
import { DictInitializerExpressionContext } from "./EscriptLooseParser";
import { DictInitializerExpressionListContext } from "./EscriptLooseParser";
import { DictInitializerContext } from "./EscriptLooseParser";
import { ArrayInitializerContext } from "./EscriptLooseParser";
import { LiteralContext } from "./EscriptLooseParser";
import { IntegerLiteralContext } from "./EscriptLooseParser";
import { FloatLiteralContext } from "./EscriptLooseParser";
/**
 * This interface defines a complete generic visitor for a parse tree produced
 * by `EscriptLooseParser`.
 *
 * @param <Result> The return type of the visit operation. Use `void` for
 * operations with no return type.
 */
export interface EscriptLooseParserVisitor<Result> extends ParseTreeVisitor<Result> {
    /**
     * Visit a parse tree produced by `EscriptLooseParser.compilationUnit`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitCompilationUnit?: (ctx: CompilationUnitContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.moduleUnit`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitModuleUnit?: (ctx: ModuleUnitContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.moduleDeclarationStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitModuleDeclarationStatement?: (ctx: ModuleDeclarationStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.moduleFunctionDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitModuleFunctionDeclaration?: (ctx: ModuleFunctionDeclarationContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.moduleFunctionParameterList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitModuleFunctionParameterList?: (ctx: ModuleFunctionParameterListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.moduleFunctionParameter`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitModuleFunctionParameter?: (ctx: ModuleFunctionParameterContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.unitExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitUnitExpression?: (ctx: UnitExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.topLevelDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitTopLevelDeclaration?: (ctx: TopLevelDeclarationContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.functionDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFunctionDeclaration?: (ctx: FunctionDeclarationContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.stringIdentifier`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitStringIdentifier?: (ctx: StringIdentifierContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.useDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitUseDeclaration?: (ctx: UseDeclarationContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.includeDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitIncludeDeclaration?: (ctx: IncludeDeclarationContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.programDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitProgramDeclaration?: (ctx: ProgramDeclarationContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.statement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitStatement?: (ctx: StatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.ifStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitIfStatement?: (ctx: IfStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.gotoStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitGotoStatement?: (ctx: GotoStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.returnStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitReturnStatement?: (ctx: ReturnStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.constStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitConstStatement?: (ctx: ConstStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.varStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitVarStatement?: (ctx: VarStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.doStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitDoStatement?: (ctx: DoStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.whileStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitWhileStatement?: (ctx: WhileStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.exitStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitExitStatement?: (ctx: ExitStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.declareStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitDeclareStatement?: (ctx: DeclareStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.breakStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitBreakStatement?: (ctx: BreakStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.continueStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitContinueStatement?: (ctx: ContinueStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.forStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitForStatement?: (ctx: ForStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.foreachStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitForeachStatement?: (ctx: ForeachStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.repeatStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitRepeatStatement?: (ctx: RepeatStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.caseStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitCaseStatement?: (ctx: CaseStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.enumStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitEnumStatement?: (ctx: EnumStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.block`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitBlock?: (ctx: BlockContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.variableDeclarationInitializer`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitVariableDeclarationInitializer?: (ctx: VariableDeclarationInitializerContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.enumList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitEnumList?: (ctx: EnumListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.enumListEntry`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitEnumListEntry?: (ctx: EnumListEntryContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.switchBlockStatementGroup`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitSwitchBlockStatementGroup?: (ctx: SwitchBlockStatementGroupContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.switchLabel`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitSwitchLabel?: (ctx: SwitchLabelContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.forGroup`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitForGroup?: (ctx: ForGroupContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.basicForStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitBasicForStatement?: (ctx: BasicForStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.cstyleForStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitCstyleForStatement?: (ctx: CstyleForStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.identifierList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitIdentifierList?: (ctx: IdentifierListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.variableDeclarationList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitVariableDeclarationList?: (ctx: VariableDeclarationListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.variableDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitVariableDeclaration?: (ctx: VariableDeclarationContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.programParameters`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitProgramParameters?: (ctx: ProgramParametersContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.programParameterList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitProgramParameterList?: (ctx: ProgramParameterListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.programParameter`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitProgramParameter?: (ctx: ProgramParameterContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.functionParameters`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFunctionParameters?: (ctx: FunctionParametersContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.functionParameterList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFunctionParameterList?: (ctx: FunctionParameterListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.functionParameter`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFunctionParameter?: (ctx: FunctionParameterContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.scopedMethodCall`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitScopedMethodCall?: (ctx: ScopedMethodCallContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.missingToken`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitMissingToken?: (ctx: MissingTokenContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.expression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitExpression?: (ctx: ExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.primary`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitPrimary?: (ctx: PrimaryContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.parExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitParExpression?: (ctx: ParExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.expressionList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitExpressionList?: (ctx: ExpressionListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.methodCallArgument`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitMethodCallArgument?: (ctx: MethodCallArgumentContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.methodCallArgumentList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitMethodCallArgumentList?: (ctx: MethodCallArgumentListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.methodCall`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitMethodCall?: (ctx: MethodCallContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.memberCall`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitMemberCall?: (ctx: MemberCallContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.structInitializerExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitStructInitializerExpression?: (ctx: StructInitializerExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.structInitializerExpressionList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitStructInitializerExpressionList?: (ctx: StructInitializerExpressionListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.structInitializer`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitStructInitializer?: (ctx: StructInitializerContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.dictInitializerExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitDictInitializerExpression?: (ctx: DictInitializerExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.dictInitializerExpressionList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitDictInitializerExpressionList?: (ctx: DictInitializerExpressionListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.dictInitializer`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitDictInitializer?: (ctx: DictInitializerContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.arrayInitializer`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitArrayInitializer?: (ctx: ArrayInitializerContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.literal`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitLiteral?: (ctx: LiteralContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.integerLiteral`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitIntegerLiteral?: (ctx: IntegerLiteralContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptLooseParser.floatLiteral`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFloatLiteral?: (ctx: FloatLiteralContext) => Result;
}
