import { ParseTreeVisitor } from "antlr4ts/tree/ParseTreeVisitor";
import { CompilationUnitContext } from "./EscriptParser";
import { ModuleUnitContext } from "./EscriptParser";
import { ModuleDeclarationStatementContext } from "./EscriptParser";
import { ModuleFunctionDeclarationContext } from "./EscriptParser";
import { ModuleFunctionParameterListContext } from "./EscriptParser";
import { ModuleFunctionParameterContext } from "./EscriptParser";
import { UnitExpressionContext } from "./EscriptParser";
import { TopLevelDeclarationContext } from "./EscriptParser";
import { FunctionDeclarationContext } from "./EscriptParser";
import { StringIdentifierContext } from "./EscriptParser";
import { UseDeclarationContext } from "./EscriptParser";
import { IncludeDeclarationContext } from "./EscriptParser";
import { ProgramDeclarationContext } from "./EscriptParser";
import { StatementContext } from "./EscriptParser";
import { IfStatementContext } from "./EscriptParser";
import { GotoStatementContext } from "./EscriptParser";
import { ReturnStatementContext } from "./EscriptParser";
import { ConstStatementContext } from "./EscriptParser";
import { VarStatementContext } from "./EscriptParser";
import { DoStatementContext } from "./EscriptParser";
import { WhileStatementContext } from "./EscriptParser";
import { ExitStatementContext } from "./EscriptParser";
import { DeclareStatementContext } from "./EscriptParser";
import { BreakStatementContext } from "./EscriptParser";
import { ContinueStatementContext } from "./EscriptParser";
import { ForStatementContext } from "./EscriptParser";
import { ForeachStatementContext } from "./EscriptParser";
import { RepeatStatementContext } from "./EscriptParser";
import { CaseStatementContext } from "./EscriptParser";
import { EnumStatementContext } from "./EscriptParser";
import { BlockContext } from "./EscriptParser";
import { VariableDeclarationInitializerContext } from "./EscriptParser";
import { EnumListContext } from "./EscriptParser";
import { EnumListEntryContext } from "./EscriptParser";
import { SwitchBlockStatementGroupContext } from "./EscriptParser";
import { SwitchLabelContext } from "./EscriptParser";
import { ForGroupContext } from "./EscriptParser";
import { BasicForStatementContext } from "./EscriptParser";
import { CstyleForStatementContext } from "./EscriptParser";
import { IdentifierListContext } from "./EscriptParser";
import { VariableDeclarationListContext } from "./EscriptParser";
import { VariableDeclarationContext } from "./EscriptParser";
import { ProgramParametersContext } from "./EscriptParser";
import { ProgramParameterListContext } from "./EscriptParser";
import { ProgramParameterContext } from "./EscriptParser";
import { FunctionParametersContext } from "./EscriptParser";
import { FunctionParameterListContext } from "./EscriptParser";
import { FunctionParameterContext } from "./EscriptParser";
import { ScopedMethodCallContext } from "./EscriptParser";
import { ExpressionContext } from "./EscriptParser";
import { PrimaryContext } from "./EscriptParser";
import { ParExpressionContext } from "./EscriptParser";
import { ExpressionListContext } from "./EscriptParser";
import { MethodCallArgumentContext } from "./EscriptParser";
import { MethodCallArgumentListContext } from "./EscriptParser";
import { MethodCallContext } from "./EscriptParser";
import { MemberCallContext } from "./EscriptParser";
import { StructInitializerExpressionContext } from "./EscriptParser";
import { StructInitializerExpressionListContext } from "./EscriptParser";
import { StructInitializerContext } from "./EscriptParser";
import { DictInitializerExpressionContext } from "./EscriptParser";
import { DictInitializerExpressionListContext } from "./EscriptParser";
import { DictInitializerContext } from "./EscriptParser";
import { ArrayInitializerContext } from "./EscriptParser";
import { LiteralContext } from "./EscriptParser";
import { IntegerLiteralContext } from "./EscriptParser";
import { FloatLiteralContext } from "./EscriptParser";
/**
 * This interface defines a complete generic visitor for a parse tree produced
 * by `EscriptParser`.
 *
 * @param <Result> The return type of the visit operation. Use `void` for
 * operations with no return type.
 */
export interface EscriptParserVisitor<Result> extends ParseTreeVisitor<Result> {
    /**
     * Visit a parse tree produced by `EscriptParser.compilationUnit`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitCompilationUnit?: (ctx: CompilationUnitContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.moduleUnit`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitModuleUnit?: (ctx: ModuleUnitContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.moduleDeclarationStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitModuleDeclarationStatement?: (ctx: ModuleDeclarationStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.moduleFunctionDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitModuleFunctionDeclaration?: (ctx: ModuleFunctionDeclarationContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.moduleFunctionParameterList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitModuleFunctionParameterList?: (ctx: ModuleFunctionParameterListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.moduleFunctionParameter`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitModuleFunctionParameter?: (ctx: ModuleFunctionParameterContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.unitExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitUnitExpression?: (ctx: UnitExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.topLevelDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitTopLevelDeclaration?: (ctx: TopLevelDeclarationContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.functionDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFunctionDeclaration?: (ctx: FunctionDeclarationContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.stringIdentifier`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitStringIdentifier?: (ctx: StringIdentifierContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.useDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitUseDeclaration?: (ctx: UseDeclarationContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.includeDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitIncludeDeclaration?: (ctx: IncludeDeclarationContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.programDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitProgramDeclaration?: (ctx: ProgramDeclarationContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.statement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitStatement?: (ctx: StatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.ifStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitIfStatement?: (ctx: IfStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.gotoStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitGotoStatement?: (ctx: GotoStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.returnStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitReturnStatement?: (ctx: ReturnStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.constStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitConstStatement?: (ctx: ConstStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.varStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitVarStatement?: (ctx: VarStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.doStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitDoStatement?: (ctx: DoStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.whileStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitWhileStatement?: (ctx: WhileStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.exitStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitExitStatement?: (ctx: ExitStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.declareStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitDeclareStatement?: (ctx: DeclareStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.breakStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitBreakStatement?: (ctx: BreakStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.continueStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitContinueStatement?: (ctx: ContinueStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.forStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitForStatement?: (ctx: ForStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.foreachStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitForeachStatement?: (ctx: ForeachStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.repeatStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitRepeatStatement?: (ctx: RepeatStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.caseStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitCaseStatement?: (ctx: CaseStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.enumStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitEnumStatement?: (ctx: EnumStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.block`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitBlock?: (ctx: BlockContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.variableDeclarationInitializer`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitVariableDeclarationInitializer?: (ctx: VariableDeclarationInitializerContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.enumList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitEnumList?: (ctx: EnumListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.enumListEntry`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitEnumListEntry?: (ctx: EnumListEntryContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.switchBlockStatementGroup`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitSwitchBlockStatementGroup?: (ctx: SwitchBlockStatementGroupContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.switchLabel`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitSwitchLabel?: (ctx: SwitchLabelContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.forGroup`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitForGroup?: (ctx: ForGroupContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.basicForStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitBasicForStatement?: (ctx: BasicForStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.cstyleForStatement`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitCstyleForStatement?: (ctx: CstyleForStatementContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.identifierList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitIdentifierList?: (ctx: IdentifierListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.variableDeclarationList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitVariableDeclarationList?: (ctx: VariableDeclarationListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.variableDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitVariableDeclaration?: (ctx: VariableDeclarationContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.programParameters`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitProgramParameters?: (ctx: ProgramParametersContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.programParameterList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitProgramParameterList?: (ctx: ProgramParameterListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.programParameter`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitProgramParameter?: (ctx: ProgramParameterContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.functionParameters`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFunctionParameters?: (ctx: FunctionParametersContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.functionParameterList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFunctionParameterList?: (ctx: FunctionParameterListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.functionParameter`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFunctionParameter?: (ctx: FunctionParameterContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.scopedMethodCall`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitScopedMethodCall?: (ctx: ScopedMethodCallContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.expression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitExpression?: (ctx: ExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.primary`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitPrimary?: (ctx: PrimaryContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.parExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitParExpression?: (ctx: ParExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.expressionList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitExpressionList?: (ctx: ExpressionListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.methodCallArgument`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitMethodCallArgument?: (ctx: MethodCallArgumentContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.methodCallArgumentList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitMethodCallArgumentList?: (ctx: MethodCallArgumentListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.methodCall`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitMethodCall?: (ctx: MethodCallContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.memberCall`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitMemberCall?: (ctx: MemberCallContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.structInitializerExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitStructInitializerExpression?: (ctx: StructInitializerExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.structInitializerExpressionList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitStructInitializerExpressionList?: (ctx: StructInitializerExpressionListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.structInitializer`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitStructInitializer?: (ctx: StructInitializerContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.dictInitializerExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitDictInitializerExpression?: (ctx: DictInitializerExpressionContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.dictInitializerExpressionList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitDictInitializerExpressionList?: (ctx: DictInitializerExpressionListContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.dictInitializer`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitDictInitializer?: (ctx: DictInitializerContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.arrayInitializer`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitArrayInitializer?: (ctx: ArrayInitializerContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.literal`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitLiteral?: (ctx: LiteralContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.integerLiteral`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitIntegerLiteral?: (ctx: IntegerLiteralContext) => Result;
    /**
     * Visit a parse tree produced by `EscriptParser.floatLiteral`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFloatLiteral?: (ctx: FloatLiteralContext) => Result;
}
